const menu = document.querySelector('.edition-nav-controls');
const editions = document.querySelectorAll('.edition-nav-edition');
const display = document.querySelector('.edition-nav-data');
let formData = {};

const isInParam = function isInParam(parameter, value) {
  let result;
  if (parameter === 'all') {
    result = true;
  } else if (
    parameter === 'documenttype:554dc16e-2e64-452a-88f9-bfb4c2c368a3'
    || parameter === 'documenttype:8525963e-2a7d-4d34-be85-3893039d733e') {
    const values = value.split('_');
    result = values.includes(parameter);
  }
  else {
    const params = parameter.split('_');
    const values = value.split('_');
    result = params.every(v => values.includes(v));
  }
  return result;
};

const sortEditions = function sortEditions(sortBy, direction) {
  const edArray = [...editions];
  if (sortBy === 'alph' && direction === 'asc') {
    edArray.sort(
      (a, b) => {
        const aId = a.id.toLowerCase();
        const bId = b.id.toLowerCase();
        if (aId < bId) {
          return -1;
        }
        if (aId > bId) {
          return 1;
        }
        return 0;
      },
    ).forEach((e) => display.appendChild(e));
  } else if (sortBy === 'alph' && direction === 'desc') {
    edArray.sort(
      (a, b) => {
        const aId = a.id.toLowerCase();
        const bId = b.id.toLowerCase();
        if (aId < bId) {
          return -1;
        }
        if (aId > bId) {
          return 1;
        }
        return 0;
      },
    ).forEach((e) => display.insertBefore(e, display.firstChild));
  } else if (direction === 'asc') {
    edArray.sort((a, b) => a.dataset.year - b.dataset.year).forEach((e) => display.appendChild(e));
  } else {
    edArray.sort((b, a) => a.dataset.year - b.dataset.year).forEach((e) => display.appendChild(e));
  }
};

const updateSelection = function selectView() {
  const newFormData = Object.fromEntries(new FormData(menu));

  if (newFormData.sort === formData.sort) {
    editions.forEach(e => {
      const inDecade = isInParam(newFormData.decade, e.dataset.year.substring(2, 3));
      const inKeywords = isInParam(newFormData.keyword, e.dataset.keywords);
      const inGenre = isInParam(newFormData.genre, e.dataset.genre);
      if (inDecade && inKeywords && inGenre) {
        e.classList.remove('hidden');
      } else {
        e.classList.add('hidden');
      }
    });
  } else {
    const sortParams = newFormData.sort.split('-');
    sortEditions(sortParams[0], sortParams[1]);
  }
  formData = newFormData;
};

if (menu) {
  formData = Object.fromEntries(new FormData(menu));
  menu.addEventListener('change', updateSelection);
}
